<mat-form-field class="extended-form-field">
  <mat-chip-list #chipList>
    <mat-chip
      *ngFor="let element of selectedElements"
      [selectable]="selectable"
      [removable]="removable"
      (removed)="remove(element)"
      (click)="openModal(element)"
      [ngClass]="getColor(element)"
    >
      <ng-container
        *ngTemplateOutlet="
          chipTemplate ? chipTemplate : chipDefault;
          context: { $implicit: element }
        "
      >
      </ng-container>

      <ng-template #chipDefault>
        {{ labelize(element) }}
      </ng-template>

      <mat-icon matChipRemove *ngIf="removable">cancel</mat-icon>
    </mat-chip>

    <input
      [placeholder]="placeholder"
      #elementInput
      [formControl]="elementCtrl"
      [matAutocomplete]="auto"
      [matChipInputFor]="chipList"
      [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
      (matChipInputTokenEnd)="entered($event)"
    />
  </mat-chip-list>
  <mat-autocomplete #auto="matAutocomplete" (optionSelected)="selected($event)">
    <mat-option
      *ngFor="let element of filteredElements | async"
      [value]="element"
    >
      <ng-container
        *ngTemplateOutlet="
          autocompleteOptionTemplate
            ? autocompleteOptionTemplate
            : optionDefault;
          context: { $implicit: element }
        "
      >
      </ng-container>

      <ng-template #optionDefault>
        {{ labelize(element) }}
      </ng-template>
    </mat-option>
  </mat-autocomplete>
</mat-form-field>
